Index: /applications/doprava/Zlicingw.cfg
===================================================================
--- /applications/doprava/Zlicingw.cfg (revision 1026)
+++ /applications/doprava/Zlicingw.cfg (revision 1067)
@@ -4,13 +4,13 @@
 	name = "495";
 	lanes = (
-			{ sg="VA"; inputs = ("495_DVA1");  outputs= (""); input_distances=[30]; output_distances=[200]; alpha= [1.0 ]; queue="495_Q1";}, 
-			{ sg="VB"; inputs = ("495_DVB1");  outputs= ("601_DVA","601_DVAa"); input_distances=[30]; output_distances=[200,200]; alpha= [0.5,0.5 ]; queue="495_Q2";},
-			{ sg="VC"; inputs = ("495_DVC");  outputs= (""); input_distances=[30]; output_distances=[200]; alpha= [1.0 ]; queue="495_Q1";}, 
-			{ sg="VD"; inputs = ("495_DVD");  outputs= (""); input_distances=[30]; output_distances=[200]; alpha= [1.0 ]; queue="495_Q2";},
-			{ sg="VE"; inputs = ("495_DVE");  outputs= ("601_DVA","601_DVAa"); input_distances=[30]; output_distances=[200,200]; alpha= [0.5,0.5 ]; queue="495_Q1";}, 
-			{ sg="VF"; inputs = ("495_DVF1");  outputs= (""); input_distances=[30]; output_distances=[200]; alpha= [1.0 ]; queue="495_Q2";}
+			{ sg="VA"; inputs = ("495_DVA1");  outputs= ("DUMMY_DET"); input_distances=[30]; output_distances=[200]; alpha= [1.0 ]; queue="495_QA"; beta=1;}, 
+			{ sg="VB"; inputs = ("495_DVB1");  outputs= ("601_DVA","601_DVAa"); input_distances=[30]; output_distances=[190,190]; alpha= [0.5,0.5 ]; queue="495_QB"; beta=1;},
+			{ sg="VC"; inputs = ("495_DVC");  outputs= ("DUMMY_DET"); input_distances=[30]; output_distances=[200]; alpha= [1.0 ]; queue="495_QC"; beta=1;}, 
+			{ sg="VD"; inputs = ("495_DVD");  outputs= ("DUMMY_DET"); input_distances=[30]; output_distances=[200]; alpha= [1.0 ]; queue="495_QD"; beta=1;},
+			{ sg="VE"; inputs = ("495_DVE");  outputs= ("601_DVA","601_DVAa"); input_distances=[30]; output_distances=[190,190]; alpha= [0.5,0.5 ]; queue="495_QE"; beta=1;}, 
+			{ sg="VF"; inputs = ("495_DVF1");  outputs= ("DUMMY_DET"); input_distances=[30]; output_distances=[200]; alpha= [1.0 ]; queue="495_QF"; beta=1;}
 	);
 	neighbours = ("601");
-  	offset = 10; //s
+  	offset = 60; //s
   	sgs=("VA","VB","VC","VD","VE","VF");
   	green_starts=[72,4,5,35,36,71];
@@ -21,12 +21,12 @@
 	name = "601";
 	lanes = (
-			{ sg="VA"; inputs = ("601_DVA");  outputs= (""); input_distances=[30]; output_distances=[200]; alpha= [1.0 ]; queue="601_Q1";}, 
-			{ sg="VA"; inputs = ("601_DVAa");  outputs= (""); input_distances=[30]; output_distances=[200]; alpha= [1.0 ]; queue="601_Q2";},
-			{ sg="VB"; inputs = ("601_DVB1");  outputs= ("495_DVC","495_DVD"); input_distances=[30]; output_distances=[200,200]; alpha= [0.5,0.5 ]; queue="601_Q1";}, 
-			{ sg="VB"; inputs = ("601_DVB1");  outputs= (""); input_distances=[30]; output_distances=[200]; alpha= [1.0 ]; queue="601_Q2";},
-			{ sg="VC"; inputs = ("601_DVC");  outputs= ("495_DVC","495_DVD"); input_distances=[30]; output_distances=[200,200]; alpha= [1.0 ]; queue="601_Q1";}, 
-			{ sg="VD"; inputs = ("601_DVD1");  outputs= (""); input_distances=[30]; output_distances=[200]; alpha= [1.0 ]; queue="601_Q2";},
-			{ sg="SE"; inputs = ("601_DSE1");  outputs= (""); input_distances=[30]; output_distances=[200]; alpha= [1.0 ]; queue="601_Q1";}, 
-			{ sg="VE"; inputs = ("601_DVE1");  outputs= ("495_DVC","495_DVD"); input_distances=[30]; output_distances=[200,200]; alpha= [0.5,0.5 ]; queue="601_Q2";}
+			{ sg="VA"; inputs = ("601_DVA");  outputs= ("DUMMY_DET","DUMMY_DET"); input_distances=[30]; output_distances=[200,200]; alpha= [0.54, 0.46 ]; queue="601_QA"; beta=0.5;}, 
+			{ sg="VA"; inputs = ("601_DVAa");  outputs= ("DUMMY_DET","DUMMY_DET"); input_distances=[30]; output_distances=[200,200]; alpha= [0.44,0.56]; queue="601_QA"; beta=0.5;},
+			{ sg="VB"; inputs = ("601_DVB1");  outputs= ("DUMMY_DET","495_DVC","495_DVD"); input_distances=[30]; output_distances=[200,190,190]; alpha= [0.1,0.4,0.5 ]; queue="601_QB"; beta=0.5;}, 
+			{ sg="VB"; inputs = ("601_DVB1");  outputs= ("DUMMY_DET"); input_distances=[30]; output_distances=[200]; alpha= [1.0 ]; queue="601_QB"; beta=0.5;},
+			{ sg="VC"; inputs = ("601_DVC");  outputs= ("495_DVC","495_DVD","DUMMY_DET"); input_distances=[30]; output_distances=[190,190,200]; alpha= [0.35,0.35,0.3 ]; queue="601_QC"; beta=1;}, 
+			{ sg="VD"; inputs = ("601_DVD1");  outputs= ("DUMMY_DET"); input_distances=[30]; output_distances=[200]; alpha= [1.0 ]; queue="601_QD"; beta=1;},
+			{ sg="SE"; inputs = ("601_DSE1");  outputs= ("DUMMY_DET"); input_distances=[30]; output_distances=[200]; alpha= [1.0 ]; queue="601_QSE"; beta=1;}, 
+			{ sg="VE"; inputs = ("601_DVE1");  outputs= ("495_DVC","495_DVD"); input_distances=[30]; output_distances=[190,190]; alpha= [0.5,0.5 ]; queue="601_QE"; beta=1;}
 	);  
 	neighbours = ("495");
@@ -49,10 +49,10 @@
 	// constant entrances: entrances = "zlicin_const01_495_601.csv";
 	//                     entrances = "zlicin_const02_495_601.csv";
-	entrances = "zlicin_const02_495_601.csv";
+	entrances = "zlicin_const01_495_601.csv";
 
 	// Simulation length. Due to design of the Aimsun simulator,
 	// simulation in our case starts always at 00:00:00. Default simulation
 	// length is 24 hours (24:00:00).
-	stop_time = "00:30:00";
+	stop_time = "01:00:00";
 	
 };